import { AllowedComponentProps } from 'vue';
import { ComponentCustomProps } from 'vue';
import { ComponentOptionsMixin } from 'vue';
import { ComputedRef } from 'vue';
import { ConvexClient } from 'convex/browser';
import { ConvexClientOptions } from 'convex/browser';
import { DefineComponent } from 'vue';
import { ExtractPropTypes } from 'vue';
import { FunctionArgs } from 'convex/server';
import { FunctionReference } from 'convex/server';
import { FunctionReturnType } from 'convex/server';
import { GenericId } from 'convex/values';
import { InjectionKey } from 'vue';
import { MaybeRef } from 'vue';
import { MaybeRefOrGetter } from 'vue';
import { OptimisticUpdate } from 'convex/browser';
import { PaginationOptions } from 'convex/server';
import { PaginationResult } from 'convex/server';
import { Plugin as Plugin_2 } from 'vue';
import { PropType } from 'vue';
import { PublicProps } from 'vue';
import { Ref } from 'vue';
import { RendererElement } from 'vue';
import { RendererNode } from 'vue';
import { RouteLocationNormalized } from 'vue-router';
import { RouteLocationRaw } from 'vue-router';
import { RouterLinkProps } from 'vue-router';
import { ShallowUnwrapRef } from 'vue';
import { UnwrapRef } from 'vue';
import { UnwrapRefSimple } from '@vue/reactivity';
import { VNode } from 'vue';
import { VNodeProps } from 'vue';

declare type __VLS_NonUndefinedable<T> = T extends undefined ? never : T;

declare type __VLS_Prettify<T> = {
    [K in keyof T]: T[K];
} & {};

declare type __VLS_TypePropsToRuntimeProps<T> = {
    [K in keyof T]-?: {} extends Pick<T, K> ? {
        type: PropType<__VLS_NonUndefinedable<T[K]>>;
    } : {
        type: PropType<T[K]>;
        required: true;
    };
};

declare type __VLS_WithDefaults<P, D> = {
    [K in keyof Pick<P, keyof P>]: K extends keyof D ? __VLS_Prettify<P[K] & {
        default: D[K];
    }> : P[K];
};

declare type __VLS_WithTemplateSlots<T, S> = T & {
    new (): {
        $slots: S;
    };
};

export declare type ActionReference = FunctionReference<"action">;

export declare type AnyRouteLoader = Record<string, RouterDefinition<QueryReference>>;

export declare const CONVEX_AUTH_INJECTION_KEY: InjectionKey<{
    isAuthenticated: Ref<boolean>;
    isLoading: Ref<boolean>;
    getToken(opts: {
        forceRefreshToken: boolean;
    }): Promise<Nullable<string>>;
}>;

export declare const CONVEX_INJECTION_KEY: InjectionKey<ConvexVueClient>;

export declare const CONVEX_LOADERS_INJECTION_KEY: InjectionKey<RouteLoaderMap>;

export declare const ConvexLink: __VLS_WithTemplateSlots<DefineComponent<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<Props>, {
    prefetch: boolean;
    prefetchTimeout: number;
}>, {}, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {}, string, PublicProps, Readonly<ExtractPropTypes<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<Props>, {
    prefetch: boolean;
    prefetchTimeout: number;
}>>>, {
    prefetch: boolean;
    prefetchTimeout: number;
}, {}>, {
    default?(_: {}): any;
}>;

export declare const ConvexPaginatedQuery: <T>(__VLS_props: {
    query: PaginatedQueryReference<T>;
    args: {};
    options: UseConvexPaginatedQueryOptions;
    suspense?: boolean | undefined;
} & VNodeProps & AllowedComponentProps & ComponentCustomProps, __VLS_ctx?: {
    attrs: any;
    slots: Readonly<{
        default(props: {
            data: UnwrapRefSimple<T>[];
            lastPage: {
                page: UnwrapRefSimple<T>[];
                isDone: boolean;
                continueCursor: string;
                splitCursor?: string | null | undefined;
                pageStatus?: "SplitRecommended" | "SplitRequired" | null | undefined;
            };
            pages: UnwrapRefSimple<T>[][];
            isDone: boolean;
            isLoadingMore: boolean;
            reset: () => void;
            loadMore: () => void;
        }): any;
        loading(props: {}): any;
        error(props: {
            error: Error;
            reset: () => void;
        }): any;
        empty(props: {}): any;
    }> & {
        default(props: {
            data: UnwrapRefSimple<T>[];
            lastPage: {
                page: UnwrapRefSimple<T>[];
                isDone: boolean;
                continueCursor: string;
                splitCursor?: string | null | undefined;
                pageStatus?: "SplitRecommended" | "SplitRequired" | null | undefined;
            };
            pages: UnwrapRefSimple<T>[][];
            isDone: boolean;
            isLoadingMore: boolean;
            reset: () => void;
            loadMore: () => void;
        }): any;
        loading(props: {}): any;
        error(props: {
            error: Error;
            reset: () => void;
        }): any;
        empty(props: {}): any;
    };
    emit: any;
} | undefined, __VLS_expose?: ((exposed: ShallowUnwrapRef<{}>) => void) | undefined, __VLS_setup?: Promise<{
    props: {
        query: PaginatedQueryReference<T>;
        args: {};
        options: UseConvexPaginatedQueryOptions;
        suspense?: boolean | undefined;
    } & VNodeProps & AllowedComponentProps & ComponentCustomProps;
    expose(exposed: ShallowUnwrapRef<{}>): void;
    attrs: any;
    slots: Readonly<{
        default(props: {
            data: UnwrapRefSimple<T>[];
            lastPage: {
                page: UnwrapRefSimple<T>[];
                isDone: boolean;
                continueCursor: string;
                splitCursor?: string | null | undefined;
                pageStatus?: "SplitRecommended" | "SplitRequired" | null | undefined;
            };
            pages: UnwrapRefSimple<T>[][];
            isDone: boolean;
            isLoadingMore: boolean;
            reset: () => void;
            loadMore: () => void;
        }): any;
        loading(props: {}): any;
        error(props: {
            error: Error;
            reset: () => void;
        }): any;
        empty(props: {}): any;
    }> & {
        default(props: {
            data: UnwrapRefSimple<T>[];
            lastPage: {
                page: UnwrapRefSimple<T>[];
                isDone: boolean;
                continueCursor: string;
                splitCursor?: string | null | undefined;
                pageStatus?: "SplitRecommended" | "SplitRequired" | null | undefined;
            };
            pages: UnwrapRefSimple<T>[][];
            isDone: boolean;
            isLoadingMore: boolean;
            reset: () => void;
            loadMore: () => void;
        }): any;
        loading(props: {}): any;
        error(props: {
            error: Error;
            reset: () => void;
        }): any;
        empty(props: {}): any;
    };
    emit: any;
}>) => VNode<RendererNode, RendererElement, {
    [key: string]: any;
}> & {
    __ctx?: {
        props: {
            query: PaginatedQueryReference<T>;
            args: {};
            options: UseConvexPaginatedQueryOptions;
            suspense?: boolean | undefined;
        } & VNodeProps & AllowedComponentProps & ComponentCustomProps;
        expose(exposed: ShallowUnwrapRef<{}>): void;
        attrs: any;
        slots: Readonly<{
            default(props: {
                data: UnwrapRefSimple<T>[];
                lastPage: {
                    page: UnwrapRefSimple<T>[];
                    isDone: boolean;
                    continueCursor: string;
                    splitCursor?: string | null | undefined;
                    pageStatus?: "SplitRecommended" | "SplitRequired" | null | undefined;
                };
                pages: UnwrapRefSimple<T>[][];
                isDone: boolean;
                isLoadingMore: boolean;
                reset: () => void;
                loadMore: () => void;
            }): any;
            loading(props: {}): any;
            error(props: {
                error: Error;
                reset: () => void;
            }): any;
            empty(props: {}): any;
        }> & {
            default(props: {
                data: UnwrapRefSimple<T>[];
                lastPage: {
                    page: UnwrapRefSimple<T>[];
                    isDone: boolean;
                    continueCursor: string;
                    splitCursor?: string | null | undefined;
                    pageStatus?: "SplitRecommended" | "SplitRequired" | null | undefined;
                };
                pages: UnwrapRefSimple<T>[][];
                isDone: boolean;
                isLoadingMore: boolean;
                reset: () => void;
                loadMore: () => void;
            }): any;
            loading(props: {}): any;
            error(props: {
                error: Error;
                reset: () => void;
            }): any;
            empty(props: {}): any;
        };
        emit: any;
    } | undefined;
};

export declare const ConvexQuery: <Query extends QueryReference>(__VLS_props: {
    query: Query;
    args: FunctionArgs<Query>;
    options?: UseConvexQueryOptions | undefined;
    suspense?: boolean | undefined;
} & VNodeProps & AllowedComponentProps & ComponentCustomProps, __VLS_ctx?: {
    attrs: any;
    slots: Readonly<{
        default(props: {
            data: Exclude<UnwrapRef<FunctionReturnType<Query>>, null | undefined>;
        }): any;
        loading(props: {}): any;
        error(props: {
            error: Error;
        }): any;
        empty(props: {}): any;
    }> & {
        default(props: {
            data: Exclude<UnwrapRef<FunctionReturnType<Query>>, null | undefined>;
        }): any;
        loading(props: {}): any;
        error(props: {
            error: Error;
        }): any;
        empty(props: {}): any;
    };
    emit: any;
} | undefined, __VLS_expose?: ((exposed: ShallowUnwrapRef<{}>) => void) | undefined, __VLS_setup?: Promise<{
    props: {
        query: Query;
        args: FunctionArgs<Query>;
        options?: UseConvexQueryOptions | undefined;
        suspense?: boolean | undefined;
    } & VNodeProps & AllowedComponentProps & ComponentCustomProps;
    expose(exposed: ShallowUnwrapRef<{}>): void;
    attrs: any;
    slots: Readonly<{
        default(props: {
            data: Exclude<UnwrapRef<FunctionReturnType<Query>>, null | undefined>;
        }): any;
        loading(props: {}): any;
        error(props: {
            error: Error;
        }): any;
        empty(props: {}): any;
    }> & {
        default(props: {
            data: Exclude<UnwrapRef<FunctionReturnType<Query>>, null | undefined>;
        }): any;
        loading(props: {}): any;
        error(props: {
            error: Error;
        }): any;
        empty(props: {}): any;
    };
    emit: any;
}>) => VNode<RendererNode, RendererElement, {
    [key: string]: any;
}> & {
    __ctx?: {
        props: {
            query: Query;
            args: FunctionArgs<Query>;
            options?: UseConvexQueryOptions | undefined;
            suspense?: boolean | undefined;
        } & VNodeProps & AllowedComponentProps & ComponentCustomProps;
        expose(exposed: ShallowUnwrapRef<{}>): void;
        attrs: any;
        slots: Readonly<{
            default(props: {
                data: Exclude<UnwrapRef<FunctionReturnType<Query>>, null | undefined>;
            }): any;
            loading(props: {}): any;
            error(props: {
                error: Error;
            }): any;
            empty(props: {}): any;
        }> & {
            default(props: {
                data: Exclude<UnwrapRef<FunctionReturnType<Query>>, null | undefined>;
            }): any;
            loading(props: {}): any;
            error(props: {
                error: Error;
            }): any;
            empty(props: {}): any;
        };
        emit: any;
    } | undefined;
};

declare class ConvexVueClient extends ConvexClient {
    mutation<Mutation extends FunctionReference<'mutation'>, Args extends FunctionArgs<Mutation>>(mutation: Mutation, args: Args, optimisticUpdate?: OptimisticUpdate<Args>): Promise<Awaited<FunctionReturnType<Mutation>>>;
}

export declare type ConvexVuePluginOptions = {
    convexUrl: string;
    clientOptions?: ConvexClientOptions;
    auth?: {
        getToken(opts: {
            forceRefreshToken: boolean;
        }): Promise<Nullable<string>>;
        isAuthenticated: Ref<boolean>;
        isLoading: Ref<boolean>;
    } & NavigationGuardOptions;
    routeLoaderMap?: RouteLoaderMap;
};

export declare const createConvexVue: ({ clientOptions, convexUrl, auth, routeLoaderMap }: ConvexVuePluginOptions) => Plugin_2;

export declare const defineRouteLoader: <T extends AnyRouteLoader>(loader: T) => TypedRouteLoader<T>;

declare type DistributiveOmit<T, K extends keyof T> = {
    [Property in keyof T as Property extends K ? never : Property]: T[Property];
};

export declare type Infer<T extends TypedRouteLoader<AnyRouteLoader>> = {
    [Key in keyof T]: ReturnType<T[Key]['args']> extends never ? 'Your loader args function returns incorrect arguments' : T[Key]['query'] extends PaginatedQueryReference<infer ResultType> ? ReturnType<typeof useConvexPaginatedQuery<ResultType>> : ReturnType<typeof useConvexQuery<T[Key]['query']>>;
};

export declare const loaders: {
    Home: TypedRouteLoader<{
        todos: {
            query: FunctionReference<"query", "public", {
                forceError?: boolean | undefined;
            }, {
                _id: GenericId<"todos">;
                _creationTime: number;
                text: string;
                completed: boolean;
            }[]>;
            args: () => {};
        };
    }>;
};

export declare type MutationReference = FunctionReference<'mutation'>;

declare type NavigationGuardOptions = {
    installNavigationGuard?: true;
    needsAuth: (to: RouteLocationNormalized, from?: RouteLocationNormalized) => boolean;
    redirectTo: (to: RouteLocationNormalized, from?: RouteLocationNormalized) => RouteLocationRaw;
} | {
    installNavigationGuard?: false;
    needsAuth?: never;
    redirectTo?: never;
};

declare type Nullable<T> = T | null | undefined;

export declare type PaginatedQueryArgs<T, Query extends PaginatedQueryReference<T>> = Prettify<DistributiveOmit<FunctionArgs<Query>, 'paginationOpts'>>;

export declare type PaginatedQueryReference<T> = FunctionReference<'query', 'public', {
    paginationOpts: PaginationOptions;
}, PaginationResult<T>>;

declare type Prettify<ObjectType extends Record<any, any>> = ObjectType extends Record<any, any> ? {
    [Key in keyof ObjectType]: ObjectType[Key];
} : never;

declare type Props = RouterLinkProps & {
    prefetch?: boolean;
    prefetchTimeout?: number;
};

export declare type QueryReference = FunctionReference<'query'>;

declare type RouteLoaderArgsGetter<Query extends QueryReference> = (route: RouteLocationNormalized) => FunctionArgs<Query>;

declare type RouteLoaderMap = Record<string, TypedRouteLoader<AnyRouteLoader>>;

declare type RouterDefinition<Query extends QueryReference> = {
    query: Query;
    args: RouteLoaderArgsGetter<Query>;
};

export declare type TypedRouteLoader<T extends AnyRouteLoader> = {
    [Key in keyof T]: T[Key] extends RouterDefinition<infer Query> ? RouterDefinition<Query> : never;
};

export declare function useConvexAction<Action extends ActionReference>(action: Action, { onSuccess, onError, }?: {
    onSuccess?: (data: FunctionReturnType<Action>) => void;
    onError?: (err: Error) => void;
}): {
    isLoading: Ref<boolean>;
    error: Ref<Nullable<Error>>;
    mutate: (args: Action["_args"]) => Promise<FunctionReturnType<Action> | undefined>;
};

export declare function useConvexMutation<Mutation extends MutationReference>(mutation: Mutation, { onSuccess, onError, optimisticUpdate }?: {
    onSuccess?: (data: FunctionReturnType<Mutation>) => void;
    onError?: (err: Error) => void;
    optimisticUpdate?: OptimisticUpdate<FunctionArgs<Mutation>>;
}): {
    isLoading: Ref<boolean>;
    error: Ref<Nullable<Error>>;
    mutate: (args: FunctionArgs<Mutation>) => Promise<FunctionReturnType<Mutation> | undefined>;
};

export declare const useConvexPaginatedQuery: <T>(query: PaginatedQueryReference<T>, args: MaybeRefOrGetter<{}>, options: {
    numItems: number;
}) => {
    suspense: () => Promise<T[][]>;
    pages: ComputedRef<UnwrapRefSimple<T>[][]>;
    data: ComputedRef<UnwrapRefSimple<T>[]>;
    lastPage: ComputedRef<{
        page: UnwrapRefSimple<T>[];
        isDone: boolean;
        continueCursor: string;
        splitCursor?: string | null | undefined;
        pageStatus?: "SplitRecommended" | "SplitRequired" | null | undefined;
    } | undefined>;
    error: Ref<Nullable<Error>>;
    isDone: Ref<boolean>;
    isLoading: ComputedRef<boolean>;
    isLoadingMore: Ref<boolean>;
    loadMore: () => void;
    reset: () => void;
};

export declare type UseConvexPaginatedQueryOptions = {
    numItems: number;
};

export declare const useConvexQuery: <Query extends QueryReference>(query: Query, args: MaybeRefOrGetter<FunctionArgs<Query>>, options?: UseConvexQueryOptions) => {
    suspense: () => Promise<FunctionReturnType<Query>>;
    data: Ref<UnwrapRef<FunctionReturnType<Query>>>;
    error: Ref<Nullable<Error>>;
    isLoading: ComputedRef<boolean>;
};

export declare type UseConvexQueryOptions = {
    enabled?: MaybeRef<boolean>;
};

export declare const useRouteLoader: <T extends TypedRouteLoader<AnyRouteLoader>>() => Infer<T>;

export { }
